

#    MIDAS Access Client  for the  AGATADigitizerAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global AGATADigitizerAccessServerHost AGATADigitizerAccessServerPort

if {[info exists AGATADigitizerAccessServerHost] == 0} then {set AGATADigitizerAccessServerHost localhost}
if {[info exists AGATADigitizerAccessServerPort] == 0} then {set AGATADigitizerAccessServerPort 8015}

variable uri "urn:AGATADigitizerAccessServer"
variable proxy "http://$AGATADigitizerAccessServerHost:$AGATADigitizerAccessServerPort/AGATADigitizerAccessServer"


SOAP::create AGATADigitizerAccessClient__Init -proxy $proxy -uri $uri -timeout 1000 \
     -name Init \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADigitizerAccessClient__Close -proxy $proxy -uri $uri -timeout 10000 \
     -name Close \
     -params {Digitizer int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADigitizerAccessClient__Set -proxy $proxy -uri $uri -timeout 10000 \
     -name Set \
     -params {Digitizer int FPGA int Address int AddressModifer string Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADigitizerAccessClient__Get -proxy $proxy -uri $uri -timeout 10000 \
     -name Get \
     -params {Digitizer int FPGA int Address int AddressModifier string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADigitizerAccessClient__Write -proxy $proxy -uri $uri -timeout 10000 \
     -name Write \
     -params {Digitizer int FPGA int Address int AddressModifer string Length int Values string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create AGATADigitizerAccessClient__Read -proxy $proxy -uri $uri -timeout 10000 \
     -name Read \
     -params {Digitizer int FPGA int Address int AddressModifier string Length int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create AGATADigitizerAccessClient__SetTimeOut -proxy $proxy -uri $uri -timeout 1000 \
     -name SetTimeOut \
     -params {Digitizer int opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create AGATADigitizerAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout 1000 \
     -name AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 



package provide AGATADigitizerAccessClient 1.0
