



#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
     variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

   get_registers

}

if {$started == 0} {          ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable HelpTopic "Comms"

    variable FADC
    variable GlobalRegisterList
    variable GlobalRegisterAddress
    variable GlobalRegister
    variable ChannelRegisterList
    variable ChannelRegisterAddress
    variable ChannelRegister
    variable GlobalValue
    variable ChannelValue
    variable gr
    variable cr
    variable SetAll
 
    set FADC 1
    set SetAll 0

    set GlobalRegisterList { \
       "Global Control" \
       "Inspection A"  \
       "Inspection B"  \
       "Inspection Enables"  \
       "Spare Allocation"  \
       "Gain & Buffer Control"  \
       "Analogue Channel Select"  \
       "Sync Phase"  \
       "Clock Control #1"   \
       "Pulser Control"   \
       "Pulser DAC"   \
    }

    set ChannelRegisterList { \
       "Channel Control"  \
       "Rocket I/O Control"  \
       "Test Data Source Select"  \
       "Insert Error"   \
    }

    set GlobalRegisterAddress {0 2 3 4 5 7 8 11 13 14 15}

    set ChannelRegisterAddress {1 3 4 5}

    set GlobalRegister [lindex $GlobalRegisterList 0]
    set ChannelRegister [lindex $ChannelRegisterList 0]

    set GlobalValue 0x0
    set ChannelValue 0x0

    for {set i 0} {$i <= 16} {incr i} {set gr($i) 0}
    for {set i 0} {$i <= 15} {incr i} {set cr($i) 0}


    proc Set_Channelfadc {w} {
        variable ChannelRegister 
        variable ChannelRegisterList 
        variable ChannelRegisterAddress 
        variable FADC
        variable ChannelValue 

        set i [lsearch $ChannelRegisterList $ChannelRegister]
        set address [lindex $ChannelRegisterAddress $i]

        for {set Ch 1} {$Ch <= 7} {incr Ch} {
            if {$w == "all" || $Ch == $FADC} then {
                set Addr [expr ($Ch * 16) + $address]
                InsertLog "Setting $ChannelRegister ([format "0x%x" $Addr]) = $ChannelValue"
                set rc [set_fadc_register $Addr $ChannelValue]
            }
        }
    }

    proc Get_Channelfadc {} {
        variable ChannelRegister 
        variable ChannelRegisterList 
        variable ChannelRegisterAddress 
        variable FADC
        variable ChannelValue 

        set i [lsearch $ChannelRegisterList $ChannelRegister]
        set address [lindex $ChannelRegisterAddress $i]

        set Addr [expr ($FADC * 16) + $address]
        set ChannelValue [get_fadc_register $Addr]
    }

    proc Set_Globalfadc {} {
        variable GlobalRegister 
        variable GlobalRegisterList 
        variable GlobalRegisterAddress 
        variable GlobalValue 

        set i [lsearch $GlobalRegisterList $GlobalRegister]
        set address [lindex $GlobalRegisterAddress $i]

        InsertLog "Setting $GlobalRegister ([format "0x%x" $address]) = $GlobalValue"

        set rc [set_fadc_register $address $GlobalValue]
    }

    proc Get_Globalfadc {} {
        variable GlobalRegister 
        variable GlobalRegisterList 
        variable GlobalRegisterAddress 
        variable GlobalValue 

        set i [lsearch $GlobalRegisterList $GlobalRegister]
        set address [lindex $GlobalRegisterAddress $i]

        set GlobalValue [get_fadc_register $address]
    }

    proc get_registers {} {
        variable ::AGATADigitizer::Fpga 
        variable ::AGATADigitizer::FpgaList 
        variable ::AGATADigitizer::FpgaIDs
        variable gr
        variable cr
        variable FADC

       set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]
 
       if {[llength $FpgaIDs] == 0 || $fpga == 3 || $fpga == 12} {

          InsertLog "Select a Virtex FPGA"

       } else {

          for {set i 0} {$i <= 16} {incr i} {   ;# global registers
             set vl [get_fadc_register $i]
             if {$vl == -1} {break}
             set gr($i) $vl
          }

          for {set i 0} {$i <= 15} {incr i} {   ;#  channel registers
             set vl [get_fadc_register [expr ([set FADC] * 16) + [set i]]]
             if {$vl == -1} {break}
             set cr($i) $vl
          }
       }
    }

    proc  show_variables {} {
        variable ::AGATADigitizer::Fpga
        variable FADC
        variable GlobalValue 
        variable GlobalRegister
        variable ChannelValue 
        variable ChannelRegister
        variable SetAll

        InsertLog "SetAll=$SetAll"
        InsertLog "Fpga=$Fpga; FADC=$FADC; GlobalValue=$GlobalValue; GlobalRegister=$GlobalRegister; ChannelValue=$ChannelValue; ChannelRegister=$ChannelRegister"
    }

    proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable SetAll

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
            InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

              switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   SELECT   {}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   HELP     {do_help}

                   Param    {
                      variable $vl
                      set $vl [lreplace [lindex $cgidata 1] 0 1]
                      switch $vl {
                         GlobalValue  {Set_Globalfadc}
                         ChannelValue {if {$SetAll == 0} {Set_Channelfadc current} else {Set_Channelfadc all}}
                         GlobalRegister  {Get_Globalfadc}
                         ChannelRegister {Get_Channelfadc}
                         default {}
                      }
                   }



                   CSETALL  {set SetAll [second [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default  {InsertLog "unexpected cgi data:  $cgidata"}
               }
           }
       }
    }

     get_registers

}  ;# end of if {$started == 0}

