


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable HelpTopic "Tests"

    variable SyncCounter 0
    variable SyncPeriod 0

    global env
    variable FirmwareDir [file join $env(MIDASBASE) TclHttpd Html AGATADigitizer Bitstreams]

    variable sources {"core bitstream" "segment bitstream" "core module RAM" "segment module RAM"}
    variable srce [first $sources]

    variable filelist {undefined}
    variable filename [first $filelist]

    variable destinations {"core module RAM" "core module segments" "core card" "segment module RAM" "segment module segments"}
    variable destination [first $destinations]

    variable Stage

    set FpgaN {"C1" "C2" "C0" "" "" "" "" "" "S1" "S2" "S3" "S4"}


   proc  show_variables {} {
        variable Digitizer
        variable FpgaList
        variable FpgaIDs
        variable Fpga
        variable srce
        variable destination
        variable filename
        variable SyncPeriod


        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        InsertLog "Digitizer=$Digitizer; Fpga=$Fpga; fpga=$fpga"
        InsertLog "source=$srce; destination=$destination; filename=$filename"
        InsertLog "SyncPeriod=$SyncPeriod"
   }


      proc get_bitstreams {} {
        variable FirmwareDir
        variable filelist
        variable filename

        set z [catch {file isdirectory $FirmwareDir} m]
        if {$z != 0 || $m == 0} {
            Alert "Unable to access $FirmwareDir or $FirmwareDir is not a directory"
            return
        }

        set arg "-name \"*bit\" "
        set z [catch {eval exec find $FirmwareDir $arg} m]

        if {$z != 0} {
            Alert "Unable to obtain firmware files: $m"
            return
        }

        set filelist {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend filelist [file tail $item]
        }

        if {[llength $filelist] == 0} {set filename "undefined"} else {set filename [first $filelist]}

     }

     proc do_download {} {
        variable FirmwareDir
        variable srce
        variable destination
        variable filename
        variable Digitizer
        variable Stage
        upvar #0 AGATADigitizerAccessServer_XportList XportList

#       if {$ModuleName == "undefined"} {Alert "please select module to program!"; return}

       set IPAddress [first [split [set XportList($Digitizer)] :]]
       set IPPort [second [split [set XportList($Digitizer)] :]]

       set FirmwareFile [file join $FirmwareDir $filename]

       if {$Stage == 0} {

          Confirm Tests "Load firmware $FirmwareFile into $destination for Digitizer $Digitizer (Address $IPAddress; Port $IPPort)\n\nThis will take some time\nTime estimated 2+ minutes"
          return
       }

       if {$Stage == 1} {

          do_close

          switch -glob $srce {

            "core bitstream"  {
               set cmd 0x20
               set file $FirmwareFile
               set cmd "[file join $FirmwareDir loader.exe] -n $IPAddress -p $IPPort -f $FirmwareFile -c $cmd"
               InsertLog "executing $cmd\\n"
               set z [catch {eval exec $cmd} m]
               InsertLog "Action completed with rc = $z and response \\n$m"
               Alert "finished"
             }
            "segment bitstream"  {
               set cmd 0xa0
               set file $FirmwareFile
               set cmd "[file join $FirmwareDir loader.exe] -n $IPAddress -p $IPPort -f $FirmwareFile -c $cmd"
               InsertLog "executing $cmd\\n"
               set z [catch {eval exec $cmd} m]
               InsertLog "Action completed with rc = $z and response \\n$m"
               Alert "finished"
             }
             default {}
          }

          Confirm Tests "Loaded source bitstream. Now ready to program destination Virtex"
          return

       }

      if {$Stage == 2} {

          do_close
       
          switch -glob $destination {

            "core module segments"  {
               set cmd 0x00
               set action 3
               set cmd "[file join $FirmwareDir loader.exe] -n $IPAddress -p $IPPort -c $cmd -a $action"
               InsertLog "executing $cmd\\n"
               set z [catch {eval exec $cmd} m]
               InsertLog "Action completed with rc = $z and response \\n$m"
               Alert "finished"
             }
            "core card"  {
               set cmd 0x00
               set action 4
               set cmd "[file join $FirmwareDir loader.exe] -n $IPAddress -p $IPPort -c $cmd -a $action"
               InsertLog "executing $cmd\\n"
               set z [catch {eval exec $cmd} m]
               InsertLog "Action completed with rc = $z and response \\n$m"
               Alert "finished"
             }
            "segment module segments"  {
               set cmd 0x80
               set action 15
               set cmd "[file join $FirmwareDir loader.exe] -n $IPAddress -p $IPPort -c $cmd -a $action"
               InsertLog "executing $cmd\\n"
               set z [catch {eval exec $cmd} m]
               InsertLog "Action completed with rc = $z and response \\n$m"
               Alert "finished"
             }
             default {}
          }

          Confirm Tests "Loaded destination"
          return

      }

      if {$Stage == 3} {

          Alert "All finished"

      }
    
   }
   
   proc set_sync {} {
        variable SyncPeriod

        variable FpgaList
        variable FpgaIDs
        variable Fpga

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]
 
        if {[llength $FpgaIDs] == 0 || $fpga != 2} {

           InsertLog "Select Core ADC card"
           return
        }

        Set_Register 0xb0 [expr $SyncPeriod & 0x0000ffff]
        Set_Register 0xb1 [expr ($SyncPeriod >> 16) & 0x0000ffff]
   }

   proc get_sync {opt} {
        variable SyncPeriod
        variable SyncCounter

        variable Digitizer
        variable FpgaList
        variable FpgaIDs
        variable Fpga

        set FpgaBAK $Fpga
        set Fpga "Core: Virtex for core ADCs"

        set LSW [Get_Register 0xb0]
        set MSW [Get_Register 0xb1]

        set SyncPeriod [format 0x%08x [expr ($MSW << 16) + $LSW]]
        set SyncCounter [Get_Register 0xb2]

        set Fpga $FpgaBAK
   }

   proc sync_err {} {
        variable Digitizer
        variable FpgaList
        variable FpgaIDs
        variable Fpga
        variable FpgaN

        foreach fpga [list 2 0 1 8 9 10 11] {
           for {set Ch 1} {$Ch < 7} {incr Ch} {
              if {$fpga == 2 && $Ch > 2} {break}
              set addr [expr ($Ch * 16) + 11]
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16} m]
              set v$Ch $m
           }
           if {$fpga == 2} {
               InsertLog "[lindex $FpgaN $fpga]: Ch1=$v1; Ch2=$v2"
           } else {
               InsertLog "[lindex $FpgaN $fpga]: Ch1=$v1; Ch2=$v2; Ch3=$v3; Ch4=$v4; Ch5=$v5; Ch6=$v6"
           }
        }
   }

   proc do_samwise {} {
        variable Digitizer
        variable Fpga
        variable Address
        variable AddressModifier
        variable Data
        variable Length

        variable FpgaList
        variable FpgaIDs

        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList "Core: Main Board"]]

        set Address 0x0c1e
        set Data 0x0100
        set AddressModifier A16

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $Address $AddressModifier 1 $Data} m]
        if {$rc != 0} {
            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            do_close
            InsertLog "Core Xport interface released; Segment Xport interface enabled. You can now launch Samwise"
        }

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Stage

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

            switch -glob [first [lindex $cgidata 1]] {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                HELP     {variable HelpTopic; set HelpTopic [second [lindex $cgidata 1]]; do_help}
                
                PROBE    {click-probe}

                FPGA       {variable Fpga; set Fpga [string range [lindex $cgidata 1] 5 end]; get_sync 1}
                DIGITIZER  {selectDigitizer [second [lindex $cgidata 1]]; get_sync 1}

                SYNC       {variable SyncPeriod; set SyncPeriod [second [lindex $cgidata 1]]; set_sync}

                FILE         {variable filename; set filename [second [lindex $cgidata 1]]}
                DESTINATION  {variable destination; set destination [second [lindex $cgidata 1]]}
                SRCE         {variable srce; set srce [second [lindex $cgidata 1]]}

                UPDTSYNC  {get_sync 0}
                SYNCERR   {sync_err}

                SHUTDOWN   {do_shutdown}
                SHOWSTATUS {do_showstatus}
                INTCLOCK   {do_clock 0x0100}
                EXTCLOCK   {do_clock 0x0000}

                CLOSEDOWN  {do_close}

                DOWNLOAD   {set Stage 0; do_download}
                CONFIRM    {incr Stage; do_download}

                SOURCE      {}
                DESTINATION {}
                FILE        {}

                SAMWISE     {do_samwise}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

   EnumerateDigitizers
   selectDigitizer [first $DigitizerList]

   get_bitstreams

}   ;# end of if {$started == 0} 

